Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 3636)
+++ palm/trunk/SOURCE/parin.f90	(revision 3637)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of the PALM module interface
+! 
+! 3569 2018-11-27 17:03:40Z kanani
 ! dom_dwd_user, Schrempf:
 ! Remove uv exposure model code, this is now part of biometeorology_mod.
@@ -468,13 +471,4 @@
                ug, u_init, v_init, vg
 
-    USE biometeorology_mod,                                                    &
-        ONLY:  bio_parin
-
-    USE bulk_cloud_model_mod,                                                  &
-        ONLY:  bcm_parin
-
-    USE chemistry_model_mod,                                                   &
-        ONLY:  chem_parin
-
     USE chem_modules
 
@@ -490,43 +484,22 @@
         ONLY:  local_dvrserver_running
 
-    USE flight_mod,                                                            &
-        ONLY:  flight_parin
-
     USE grid_variables,                                                        &
         ONLY:  dx, dy
 
-    USE gust_mod,                                                              &
-        ONLY: gust_parin
-
     USE indices,                                                               &
         ONLY:  nx, ny, nz
 
-    USE indoor_model_mod,                                                      &
-        ONLY:  im_parin
-
     USE kinds
-
-    USE land_surface_model_mod,                                                &
-        ONLY: lsm_parin
 
     USE model_1d_mod,                                                          &
         ONLY:  damp_level_1d, dt_pr_1d, dt_run_control_1d, end_time_1d
 
-    USE multi_agent_system_mod,                                                &
-        ONLY:  mas_parin
-
-    USE nesting_offl_mod,                                                      &
-        ONLY:  nesting_offl_parin
-        
+    USE module_interface,                                                      &
+        ONLY:  module_interface_parin
+
     USE netcdf_interface,                                                      &
         ONLY:  netcdf_data_format, netcdf_deflate, netcdf_precision
 
-    USE ocean_mod,                                                             &
-        ONLY:  ocean_parin
-
     USE pegrid
-
-    USE plant_canopy_model_mod,                                                &
-         ONLY: pcm_parin
 
     USE pmc_interface,                                                         &
@@ -539,39 +512,15 @@
         ONLY :  progress_bar_disabled
 
-    USE radiation_model_mod,                                                   &
-        ONLY: radiation_parin
-
     USE read_restart_data_mod,                                                 &
-        ONLY:  rrd_global  
-             
-    USE salsa_mod,                                                             &
-        ONLY: salsa_parin          
-
-    USE spectra_mod,                                                           &
-        ONLY :  spectra_parin
+        ONLY:  rrd_global
 
     USE statistics,                                                            &
         ONLY:  hom, hom_sum, pr_palm, region, statistic_regions
 
-    USE surface_output_mod,                                                    &
-        ONLY:  surface_output_parin
-
-    USE synthetic_turbulence_generator_mod,                                    &
-        ONLY:  stg_parin
-
     USE turbulence_closure_mod,                                                &
         ONLY:  rans_const_c, rans_const_sigma
 
-    USE urban_surface_mod,                                                     &
-        ONLY: usm_parin
-
     USE vertical_nesting_mod,                                                  &
         ONLY:  vnest_start_time
-        
-    USE virtual_measurement_mod,                                               &
-        ONLY:  vm_parin
-
-    USE wind_turbine_model_mod,                                                &
-        ONLY:  wtm_parin
 
 
@@ -917,27 +866,5 @@
 !
 !--       Check for module namelists and read them
-          CALL bio_parin
-          CALL lsm_parin
-          CALL bcm_parin
-          CALL surface_output_parin
-          CALL usm_parin
-          CALL spectra_parin
-          CALL radiation_parin
-          CALL gust_parin
-          CALL mas_parin
-          CALL nesting_offl_parin
-          CALL ocean_parin
-          CALL pcm_parin
-          CALL package_parin
-          CALL wtm_parin
-          CALL flight_parin
-          CALL stg_parin
-          CALL chem_parin
-          CALL im_parin
-          CALL salsa_parin
-          CALL vm_parin
-!
-!--       Read user-defined variables
-          CALL user_parin
+          CALL module_interface_parin
 
 !
Index: palm/trunk/SOURCE/read_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 3636)
+++ palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 3637)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of the PALM module interface
+! 
+! 3589 2018-11-30 15:09:51Z suehring
 ! Move the control parameter "salsa" from salsa_mod to control_parameters 
 ! (M. Kurppa)
@@ -88,8 +91,68 @@
 
 
-    USE control_parameters
+    USE arrays_3d,                                                             &
+        ONLY:  inflow_damping_factor, mean_inflow_profiles, pt_init,           &
+               q_init, ref_state, sa_init, s_init, u_init, ug, v_init, vg,     &
+               e, kh, km, p, pt, q, ql, s, u, u_m_l, u_m_n, u_m_r, u_m_s,      &
+               v, v_m_l, v_m_n, v_m_r, v_m_s, vpt, w, w_m_l, w_m_n, w_m_r, w_m_s
+
+    USE averaging
 
     USE chem_modules,                                                                              &
        ONLY: max_pr_cs
+
+    USE control_parameters
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+
+    USE date_and_time_mod,                                                     &
+        ONLY:  day_of_year_init, time_utc_init
+
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy
+
+    USE indices,                                                               &
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, nx_on_file, ny, nys, nysg, nyn, &
+               nyng, ny_on_file, nz, nzb, nzt
+
+    USE kinds
+
+    USE model_1d_mod,                                                          &
+        ONLY:  damp_level_1d, dt_pr_1d, dt_run_control_1d, end_time_1d
+
+    USE module_interface,                                                      &
+        ONLY:  module_interface_rrd_global,                                    &
+               module_interface_rrd_local
+
+    USE netcdf_interface,                                                      &
+        ONLY:  netcdf_precision, output_for_t0
+
+    USE particle_attributes,                                                   &
+        ONLY:  curvature_solution_effects, iran_part
+
+    USE pegrid
+
+    USE radiation_model_mod,                                                   &
+        ONLY:  time_radiation
+
+    USE random_function_mod,                                                   &
+        ONLY:  random_iv, random_iy
+
+    USE random_generator_parallel,                                             &
+        ONLY:  id_random_array, seq_random_array
+
+    USE spectra_mod,                                                           &
+        ONLY:  average_count_sp, spectrum_x, spectrum_y
+
+    USE surface_mod,                                                           &
+        ONLY :  surface_rrd_local
+
+    USE statistics,                                                            &
+        ONLY:  statistic_regions, hom, hom_sum, pr_palm, u_max, u_max_ijk,     &
+               v_max, v_max_ijk, w_max, w_max_ijk, z_i
+
+    USE vertical_nesting_mod,                                                  &
+        ONLY:  vnest_init
 
 
@@ -127,65 +190,4 @@
     SUBROUTINE rrd_global
 
-
-       USE arrays_3d,                                                          &
-           ONLY:  inflow_damping_factor, mean_inflow_profiles, pt_init,        &
-                  q_init, ref_state, sa_init, s_init, u_init, ug, v_init, vg
-
-       USE bulk_cloud_model_mod,                                               &
-           ONLY:  bcm_rrd_global
-
-       USE date_and_time_mod,                                                  &
-           ONLY:  day_of_year_init, time_utc_init
-
-       USE flight_mod,                                                         &
-           ONLY: flight_rrd_global
-
-       USE grid_variables,                                                     &
-           ONLY:  dx, dy
-
-       USE gust_mod,                                                           &
-           ONLY :  gust_rrd_global
-
-       USE indices,                                                            &
-           ONLY:  nz, nx, nx_on_file, ny, ny_on_file
-
-       USE model_1d_mod,                                                       &
-           ONLY:  damp_level_1d, dt_pr_1d, dt_run_control_1d, end_time_1d
-
-       USE netcdf_interface,                                                   &
-           ONLY:  netcdf_precision, output_for_t0
-
-       USE ocean_mod,                                                          &
-           ONLY:  ocean_rrd_global
-
-       USE particle_attributes,                                                &
-           ONLY:  curvature_solution_effects
-
-       USE pegrid
-
-       USE radiation_model_mod,                                                &
-           ONLY:  time_radiation
-
-       USE spectra_mod,                                                        &
-           ONLY:  average_count_sp, spectrum_x, spectrum_y
-
-       USE statistics,                                                         &
-           ONLY:  statistic_regions, hom, hom_sum, pr_palm, u_max, u_max_ijk,  &
-                  v_max, v_max_ijk, w_max, w_max_ijk, z_i
-
-       USE synthetic_turbulence_generator_mod,                                 &
-           ONLY: stg_rrd_global
-
-       USE user_read_restart_data_mod,                                         &
-           ONLY:  user_rrd_global 
-
-       USE vertical_nesting_mod,                                               &
-           ONLY:  vnest_init
-
-       USE wind_turbine_model_mod,                                             &
-           ONLY: wtm_rrd_global
-
-
-       IMPLICIT NONE
 
        CHARACTER (LEN=10) ::  binary_version_global, version_on_file
@@ -772,13 +774,5 @@
 !
 !--             Read global variables from of other modules
-                IF ( .NOT. found )  CALL bcm_rrd_global( found )
-                IF ( .NOT. found )  CALL flight_rrd_global( found )
-                IF ( .NOT. found )  CALL gust_rrd_global( found )
-                IF ( .NOT. found )  CALL ocean_rrd_global( found )
-                IF ( .NOT. found )  CALL stg_rrd_global ( found )
-                IF ( .NOT. found )  CALL wtm_rrd_global( found )
-!
-!--             Read user-defined global variables
-                IF ( .NOT. found )  CALL user_rrd_global( found )
+                CALL module_interface_rrd_global( restart_string(1:length), found )
 
                 IF ( .NOT. found )  THEN
@@ -818,19 +812,4 @@
     SUBROUTINE rrd_read_parts_of_global
 
-
-       USE arrays_3d,                                                          &
-           ONLY:  ref_state
-
-       USE indices,                                                            &
-           ONLY:  nz, nx_on_file, ny_on_file
-
-       USE kinds
-
-       USE pegrid
-
-       USE statistics,                                                         &
-           ONLY:  statistic_regions, hom, hom_sum, pr_palm
-
-       IMPLICIT NONE
 
        CHARACTER (LEN=10) ::  version_on_file
@@ -959,5 +938,5 @@
                    WRITE( message_string, * ) 'inflow profiles not ',          &
                                   'temporally averaged. &Averaging will be ',  &
-                                  'done now using', average_count_pr,          & 
+                                  'done now using', average_count_pr,          &
                                   ' samples.'
                    CALL message( 'rrd_read_parts_of_global', 'PA0309',         &
@@ -1043,65 +1022,6 @@
 !> (binary format).
 !------------------------------------------------------------------------------!
- SUBROUTINE rrd_local 
- 
-
-    USE arrays_3d,                                                             &
-        ONLY:  e, kh, km, p, pt, q, ql, s, u, u_m_l, u_m_n, u_m_r, u_m_s,      &
-               v, v_m_l, v_m_n, v_m_r, v_m_s, vpt, w, w_m_l, w_m_n, w_m_r, w_m_s
-
-    USE bulk_cloud_model_mod,                                                  &
-        ONLY :  bcm_rrd_local
-
-    USE averaging
-
-    USE chemistry_model_mod,                                                   &
-        ONLY:  chem_rrd_local
-
-    USE cpulog,                                                                &
-        ONLY:  cpu_log, log_point_s
-
-    USE gust_mod,                                                              &
-        ONLY :  gust_rrd_local
-
-    USE indices,                                                               &
-        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, nx_on_file, ny, nys, nysg, nyn, &
-               nyng, ny_on_file, nzb, nzt
-
-    USE kinds
-
-    USE land_surface_model_mod,                                                &
-        ONLY:  lsm_rrd_local
-
-    USE ocean_mod,                                                             &
-        ONLY:  ocean_rrd_local
-
-    USE particle_attributes,                                                   &
-        ONLY:  iran_part
-
-    USE pegrid
-
-    USE radiation_model_mod,                                                   &
-        ONLY: radiation_rrd_local
-
-    USE random_function_mod,                                                   &
-        ONLY:  random_iv, random_iy
-
-    USE random_generator_parallel,                                             &
-        ONLY:  id_random_array, seq_random_array
-    
-    USE salsa_mod,                                                             &
-        ONLY:  salsa_rrd_local
-
-    USE surface_mod,                                                           &
-        ONLY :  surface_rrd_local
-        
-    USE urban_surface_mod,                                                     &
-        ONLY:  usm_rrd_local
-
-    USE user_read_restart_data_mod,                                            &
-        ONLY:  user_rrd_local 
- 
-
-    IMPLICIT NONE
+ SUBROUTINE rrd_local
+
 
     CHARACTER (LEN=7)  ::  myid_char_save
@@ -1866,48 +1786,6 @@
 
 !
-!--                Read restart data of other modules
-                   IF ( .NOT. found ) CALL bcm_rrd_local( i, k, nxlf,          &
-                                           nxlc, nxl_on_file, nxrf, nxrc,      &
-                                           nxr_on_file, nynf, nync,            &
-                                           nyn_on_file, nysf, nysc,            &
-                                           nys_on_file, tmp_2d, tmp_3d, found )
-
-                   IF ( .NOT. found ) CALL chem_rrd_local( i, k, nxlf,         &
-                                           nxlc, nxl_on_file, nxrf, nxrc,      &
-                                           nxr_on_file, nynf, nync,            & 
-                                           nyn_on_file, nysf, nysc,            &
-                                           nys_on_file, tmp_3d, found )
-
-                   IF ( .NOT. found ) CALL gust_rrd_local( i, k, nxlf,         &
-                                           nxlc, nxl_on_file, nxrf, nxrc,      &
-                                           nxr_on_file, nynf, nync,            &
-                                           nyn_on_file, nysf, nysc,            &
-                                           nys_on_file, tmp_2d, tmp_3d, found )
-
-                   IF ( .NOT. found ) CALL lsm_rrd_local( i, k, nxlf,          & 
-                                           nxlc, nxl_on_file, nxrf, nxrc,      &
-                                           nxr_on_file, nynf, nync,            &
-                                           nyn_on_file, nysf, nysc,            &
-                                           nys_on_file, tmp_2d, found )
-
-                   IF ( .NOT. found ) CALL ocean_rrd_local( i, k, nxlf,        &
-                                           nxlc, nxl_on_file, nxrf, nxrc,      &
-                                           nxr_on_file, nynf, nync,            &
-                                           nyn_on_file, nysf, nysc,            &
-                                           nys_on_file, tmp_2d, tmp_3d, found )
-
-                   IF ( .NOT. found ) CALL radiation_rrd_local( i, k, nxlf,    &
-                                           nxlc, nxl_on_file, nxrf, nxrc,      &
-                                           nxr_on_file, nynf, nync,            &
-                                           nyn_on_file, nysf, nysc,            &
-                                           nys_on_file, tmp_2d, tmp_3d, found )
-
+!--                Read restart data of surfaces
                    IF ( .NOT. found ) CALL surface_rrd_local( i, k, nxlf,      &
-                                           nxlc, nxl_on_file, nxrf, nxrc,      &
-                                           nxr_on_file, nynf, nync,            & 
-                                           nyn_on_file, nysf, nysc,            &
-                                           nys_on_file, found )
-
-                   IF ( .NOT. found ) CALL usm_rrd_local( i, k, nxlf,          &
                                            nxlc, nxl_on_file, nxrf, nxrc,      &
                                            nxr_on_file, nynf, nync,            &
@@ -1915,17 +1793,13 @@
                                            nys_on_file, found )
 
-                   IF ( .NOT. found  .AND.  salsa )  CALL salsa_rrd_local( i,  &
-                                           k, nxlf, nxlc, nxl_on_file, nxrf,   &
-                                           nxrc, nxr_on_file, nynf, nync,      & 
-                                           nyn_on_file, nysf, nysc,            &
-                                           nys_on_file, tmp_3d, found )                                        
-
-!
-!--                Read user-defined restart data
-                   IF ( .NOT. found ) CALL user_rrd_local( i, k, nxlf,         &
-                                           nxlc, nxl_on_file, nxrf, nxrc,      &
-                                           nxr_on_file, nynf, nync,            &
-                                           nyn_on_file, nysf, nysc,            &
-                                           nys_on_file, tmp_3d, found )
+!
+!--                Read restart data of other modules
+                   IF ( .NOT. found ) CALL module_interface_rrd_local(         &
+                                           restart_string(1:length), i, k,     &
+                                           nxlf, nxlc, nxl_on_file,            &
+                                           nxrf, nxrc, nxr_on_file,            &
+                                           nynf, nync, nyn_on_file,            &
+                                           nysf, nysc, nys_on_file,            &
+                                           tmp_2d, tmp_3d, found )
 
 
@@ -1994,6 +1868,4 @@
 
 
-       IMPLICIT NONE
-
        CHARACTER (LEN=1) ::  cdum
 
@@ -2005,5 +1877,5 @@
 
           READ ( 13 )  cdum
-          READ ( 13 )  length 
+          READ ( 13 )  length
           READ ( 13 )  restart_string(1:length)
 
Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 3636)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 3637)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Implementation of the PALM module interface
+! 
+! 3636 2018-12-19 13:48:34Z raasch
 ! nopointer option removed
 ! 
@@ -91,5 +94,5 @@
 
     USE control_parameters
-        
+
     USE indices,                                                               &
         ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb,  &
@@ -1956,4 +1959,5 @@
     INTEGER(iwp) ::  g  !<
 
+    IF ( simulated_time >= time_since_reference_point )  THEN
 
     SELECT CASE ( mod_count )
@@ -2010,4 +2014,6 @@
 
     END SELECT
+
+    ENDIF
 
  END SUBROUTINE salsa_swap_timelevel
Index: palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3636)
+++ palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3637)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of the PALM module interface
+! 
+! 3597 2018-12-04 08:40:18Z maronga
 ! Added output of theta_2m
 ! 
@@ -259,16 +262,9 @@
         ONLY:  c_p, lv_d_cp, l_v
 
-    USE biometeorology_mod,                                                    &
-        ONLY:  bio_3d_data_averaging
-
     USE bulk_cloud_model_mod,                                                  &
-        ONLY:  bulk_cloud_model, bcm_3d_data_averaging
-
-    USE chemistry_model_mod,                                                   &
-        ONLY:  chem_3d_data_averaging
+        ONLY:  bulk_cloud_model
 
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry, average_count_3d, biometeorology, doav, doav_n,  &
-               land_surface, ocean_mode, rho_surface, salsa, urban_surface,    &
+        ONLY:  average_count_3d, doav, doav_n, rho_surface, urban_surface,     &
                varnamelength
 
@@ -276,7 +272,4 @@
         ONLY:  cpu_log, log_point
 
-    USE gust_mod,                                                              &
-        ONLY:  gust_3d_data_averaging, gust_module_enabled
-
     USE indices,                                                               &
         ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt 
@@ -284,18 +277,9 @@
     USE kinds
 
-    USE land_surface_model_mod,                                                &
-        ONLY:  lsm_3d_data_averaging
-
-    USE ocean_mod,                                                             &
-        ONLY:  ocean_3d_data_averaging
+    USE module_interface,                                                      &
+        ONLY:  module_interface_3d_data_averaging
 
     USE particle_attributes,                                                   &
         ONLY:  grid_particles, number_of_particles, particles, prt_count
-
-    USE radiation_model_mod,                                                   &
-        ONLY:  radiation, radiation_3d_data_averaging
-         
-    USE salsa_mod,                                                             &
-        ONLY:  salsa_3d_data_averaging          
 
     USE surface_mod,                                                           &
@@ -307,5 +291,5 @@
 
     USE urban_surface_mod,                                                     &
-        ONLY:  usm_average_3d_data
+        ONLY:  usm_3d_data_averaging
 
 
@@ -535,48 +519,11 @@
 
 !
-!--             Allocating and initializing data arrays for other modules
-
-                IF ( air_chemistry  .AND. &
-                     (trimvar(1:3) == 'kc_' .OR. trimvar(1:3) == 'em_') )  THEN
-                   CALL chem_3d_data_averaging( 'allocate', doav(ii) )
-                ENDIF
-
-                IF ( bulk_cloud_model )  THEN
-                   CALL bcm_3d_data_averaging( 'allocate', doav(ii) )
-                ENDIF
-
-                IF ( gust_module_enabled )  THEN
-                   CALL gust_3d_data_averaging( 'allocate', doav(ii) )
-                ENDIF
-
-                IF ( biometeorology )  THEN
-                   CALL bio_3d_data_averaging( 'allocate', doav(ii) )
-                ENDIF
-
-                IF ( land_surface )  THEN
-                   CALL lsm_3d_data_averaging( 'allocate', doav(ii) )
-                ENDIF
-
-                IF ( ocean_mode )  THEN
-                   CALL ocean_3d_data_averaging( 'allocate', doav(ii) )
-                ENDIF
-
-                IF ( radiation )  THEN
-                   CALL radiation_3d_data_averaging( 'allocate', doav(ii) )
-                ENDIF
-
-                IF ( salsa )  THEN
-                   CALL salsa_3d_data_averaging( 'allocate', doav(ii) )
-                ENDIF                
-
-                CALL tcm_3d_data_averaging( 'allocate', doav(ii) )
-
-                IF ( urban_surface  .AND.  trimvar(1:4) == 'usm_' )  THEN
-                   CALL usm_average_3d_data( 'allocate', doav(ii) )
-                ENDIF
-
-!
-!--             User-defined quantities
-                CALL user_3d_data_averaging( 'allocate', doav(ii) )
+!--             Allocating and initializing data arrays for turbulence closure module
+                CALL tcm_3d_data_averaging( 'allocate', trimvar )
+
+!
+!--             Allocating and initializing data arrays for all other modules
+                CALL module_interface_3d_data_averaging( 'allocate', trimvar )
+
 
           END SELECT
@@ -1183,52 +1130,20 @@
 
           CASE DEFAULT
-!
-!--          Summing up data from other modules
-             IF ( bulk_cloud_model )  THEN
-                CALL bcm_3d_data_averaging( 'sum', doav(ii) )
-             ENDIF
-
-             IF ( air_chemistry  .AND. &
-                  (trimvar(1:3) == 'kc_' .OR. trimvar(1:3) == 'em_') )  THEN
-                CALL chem_3d_data_averaging( 'sum',doav(ii) )
-             ENDIF
-
-             IF ( gust_module_enabled )  THEN
-                CALL gust_3d_data_averaging( 'sum', doav(ii) )
-             ENDIF
-
-             IF ( biometeorology )  THEN
-                CALL bio_3d_data_averaging( 'sum', doav(ii) )
-             ENDIF
-
-             IF ( land_surface )  THEN
-                CALL lsm_3d_data_averaging( 'sum', doav(ii) )
-             ENDIF
-
-             IF ( ocean_mode )  THEN
-                CALL ocean_3d_data_averaging( 'sum', doav(ii) )
-             ENDIF
-
-             IF ( radiation )  THEN
-                CALL radiation_3d_data_averaging( 'sum', doav(ii) )
-             ENDIF
-
-             IF ( salsa )  THEN
-                CALL salsa_3d_data_averaging( 'sum', doav(ii) )
-             ENDIF                 
-
-             CALL tcm_3d_data_averaging( 'sum', doav(ii) )
 
 !--          In case of urban surface variables it should be always checked
 !--          if respective arrays are allocated, at least in case of a restart
 !--          run, as averaged usm arrays are not read from file at the moment.
-             IF ( urban_surface  .AND.  trimvar(1:4) == 'usm_' )  THEN
-                CALL usm_average_3d_data( 'allocate', doav(ii) )
-                CALL usm_average_3d_data( 'sum', doav(ii) )
-             ENDIF
-
-!
-!--          User-defined quantities
-             CALL user_3d_data_averaging( 'sum', doav(ii) )
+             IF ( urban_surface )  THEN
+                CALL usm_3d_data_averaging( 'allocate', trimvar )
+             ENDIF
+
+!
+!--          Summing up data from turbulence closure module
+             CALL tcm_3d_data_averaging( 'sum', trimvar )
+
+!
+!--          Summing up data from all other modules
+             CALL module_interface_3d_data_averaging( 'sum', trimvar )
+
 
        END SELECT
Index: palm/trunk/SOURCE/swap_timelevel.f90
===================================================================
--- palm/trunk/SOURCE/swap_timelevel.f90	(revision 3636)
+++ palm/trunk/SOURCE/swap_timelevel.f90	(revision 3637)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of the PALM module interface
+! 
+! 3636 2018-12-19 13:48:34Z raasch
 ! nopointer option removed
 ! 
@@ -151,43 +154,25 @@
                v, v_1, v_2, v_p, w, w_1, w_2, w_p
 
-    USE bulk_cloud_model_mod,                                                  &
-        ONLY:  bulk_cloud_model, bcm_swap_timelevel
-
-    USE chemistry_model_mod,                                                   &
-        ONLY:  chem_swap_timelevel 
-
     USE cpulog,                                                                &
         ONLY: cpu_log, log_point
 
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry, humidity, land_surface, neutral, ocean_mode,     &
-               passive_scalar, simulated_time, timestep_count, urban_surface,  &
-               time_since_reference_point, salsa
-
-    USE gust_mod,                                                              &
-        ONLY: gust_module_enabled, gust_swap_timelevel
-
-    USE land_surface_model_mod,                                                &
-        ONLY: lsm_swap_timelevel
-
-    USE ocean_mod,                                                             &
-        ONLY:  ocean_swap_timelevel
+        ONLY:  humidity, neutral, passive_scalar, timestep_count
+
+    USE kinds
+
+    USE module_interface,                                                      &
+        ONLY:  module_interface_swap_timelevel
 
     USE pmc_interface,                                                         &
         ONLY: nested_run, pmci_set_swaplevel
-         
-    USE salsa_mod,                                                             &
-        ONLY:  salsa_swap_timelevel, skip_time_do_salsa             
 
     USE turbulence_closure_mod,                                                &
         ONLY:  tcm_swap_timelevel
 
-    USE urban_surface_mod,                                                     &
-        ONLY:  usm_swap_timelevel
-
 
     IMPLICIT NONE
 
-    INTEGER ::  swap_level  !> swap_level for steering the pmc data transfer
+    INTEGER(iwp) ::  swap_level  !> swap_level for steering the pmc data transfer
 
 !
@@ -237,31 +222,11 @@
     END SELECT
 
-    IF ( humidity  .AND.  bulk_cloud_model )  THEN
-       CALL bcm_swap_timelevel( MOD( timestep_count, 2) )
-    ENDIF
-
-    IF ( air_chemistry )  CALL chem_swap_timelevel( MOD( timestep_count, 2) )
-
-    IF ( gust_module_enabled )  THEN
-       CALL gust_swap_timelevel( MOD( timestep_count, 2) )
-    ENDIF
-
-    IF ( land_surface )  THEN
-       CALL lsm_swap_timelevel( MOD( timestep_count, 2) )
-    ENDIF
-
-    IF ( ocean_mode )  THEN
-       CALL ocean_swap_timelevel( MOD( timestep_count, 2 ) )
-    ENDIF
-   
-    IF ( salsa  .AND.  simulated_time >= time_since_reference_point )  THEN
-       CALL salsa_swap_timelevel(  MOD( timestep_count, 2 ) )
-    ENDIF     
-
+!
+!-- Set the swap level the turbulence closure module
     CALL tcm_swap_timelevel( MOD( timestep_count, 2) )
 
-    IF ( urban_surface )  THEN
-       CALL usm_swap_timelevel( MOD( timestep_count, 2) )
-    ENDIF
+!
+!-- Set the swap level for all other modules
+    CALL module_interface_swap_timelevel( MOD( timestep_count, 2) )
 
 !
